<template>
  <div>
    <ObMenuDropdown
      ref="menu"
      v-if="items && items.length"
      :items="items"
      :class="[ 'tender-menu', { 'is-pending': isMenuPending } ]"
      @open-delete-modal="openModal('delete-modal')"
      @open-cancel-modal="openModal('cancel-modal')"
      @open-manual-finish-modal="openModal('manual-finish-modal')"
      @open-recall-modal="openModal('recall-modal')"
      @create-new-stage="createNewStage"
      @archive-tender="archiveTender"
      @duplicate-tender="onDuplicateTender"
      @reject-participation="rejectTender"
      icon="more"
    />

    <ObModal
      ref="delete-modal"
      title="Удаление черновика"
      size="medium"
      ok-text="Удалить"
      :is-show-controls="true"
      @submit="onDeleteModalConfirm"
    >
      <div class="modal-tender-text">
        После удаления вы не сможете восстановить внесенные данные.
        Вы точно хотите удалить черновик тендера <strong>«{{ tenderInfo.title }}»</strong>?
      </div>
    </ObModal>

    <ObModal
      ref="cancel-modal"
      title="Отмена тендера"
      size="medium"
      ok-text="Отменить тендер"
      cancel-text="Не отменять"
      :is-show-controls="true"
      @submit="onCancelModalConfirm"
    >
      <div class="modal-tender-text">
        После отмены тендера вы не сможете опубликовать его снова.
        Вы точно хотите отменить тендер <strong>«{{ tenderInfo.title }}»</strong>?
      </div>

      <ObAlert
        icon="info"
        :hide-close-button="true"
      >
        Учтите, комментарий увидят все участники тендера.
        Не указывайте ваши контактные данные или любую важную
        информацию по конкретному поставщику в тексте комментария.
      </ObAlert>

      <ObTextarea
        v-model="cancelTenderComment"
        label="Ваш комментарий"
        placeholder="Введите текст"
      />
    </ObModal>

    <ObModal
      ref="manual-finish-modal"
      title="Досрочное завершение тендера"
      size="medium"
      ok-text="Завершить досрочно"
      cancel-text="Не завершать"
      :is-show-controls="true"
      @submit="onManualFinishModalConfirm"
    >
      <div class="modal-tender-text">
        Сбор предложений будет завершен через 24 часа, все перевозчики
        получат уведомление на электронную почту. Новая дата завершения
        сбора предложений появляется в общих данных по тендеру.
      </div>
    </ObModal>

    <ObModal
      ref="recall-modal"
      title="Отзыв на редактирование"
      size="medium"
      ok-text="Отозвать"
      :isShowControls="true"
      @submit="onRecallOfferModalConfirm"
    >
      <div class="modal-tender-text">
        После того, как вы отзовете предложение на редактирование, оно будет удалено у организатора и для участия в тендере вам нужно будет отправить его заново.
      </div>
    </ObModal>
  </div>
</template>

<script>
  import ObMenuDropdown from "common-components/src/obComponents/obMenuDropdown";
  import ObModal from "common-components/src/obComponents/obModal";
  import ObAlert from "common-components/src/obComponents/obAlert";
  import ObTextarea from "common-components/src/obComponents/obTextarea";
  import moment from "moment";
  import { uuid } from "vue-uuid";
  import { mapActions, mapGetters } from "vuex";
  import api from "@/api";

  export default {
    name: "tenders-menu",
    components: {
      ObMenuDropdown,
      ObModal,
      ObAlert,
      ObTextarea
    },
    props: {
      data: {
        type: [ Object, null ],
        default: null
      },
      compactMode: {
        type: Boolean,
        default: false
      }
    },
    data () {
      return {
        isMenuPending: false,
        cancelTenderComment: null
      }
    },
    computed: {
      ...mapGetters({
        tender: "tenders/tender",
        currentRole: "tenders/currentRole",
        isScenarioWinnerExists: "tenders/isScenarioWinnerExists"
      }),
      tenderInfo: {
        get () {
          return this.data || this.$store.getters[`tenders/tenderInfo`]
        }
      },
      items () {
        let menu = [];

        const newStageButton = {
          title: 'Новый этап',
          event: 'create-new-stage',
          className: this.isScenarioWinnerExists ? 'tender-menu-button' : 'tender-menu-button disabled',
          description: this.isScenarioWinnerExists ? null : 'Создать новый этап можно только после выбора итогового сценария',
          icon: this.isScenarioWinnerExists ? null : 'alert',
          isHidden: this.compactMode,
          pos: 3
        }

        if (this.currentRole === 'client') {
          switch (this.tenderInfo.status) {
            case 'DRAFT': {
              menu = [
                {
                  title: 'Удалить черновик',
                  event: 'open-delete-modal',
                  pos: 1
                }
              ];
              break;
            }

            case 'HELD': {
              menu = [
                {
                  title: 'Отменить тендер',
                  event: 'open-cancel-modal',
                  pos: 1
                }
              ];

              // Move to upper variable when appliable for both RFQ and RFI
              if (this.tenderInfo.type === 'RFQ' && !this.compactMode) {
                const hoursTillFinish = moment(this.tenderInfo.targetFinishDt).diff(moment(), 'hours');
                const manualFinishDisabled = hoursTillFinish <= 24;

                menu = [...menu, {
                  title: manualFinishDisabled ? 'Досрочное завершение невозможно (до окончания сбора предложений менее 24 часов)' : 'Досрочно завершить тендер',
                  event: 'open-manual-finish-modal',
                  className: manualFinishDisabled ? 'tender-menu-button disabled manual-finish' : 'tender-menu-button',
                  pos: 4
                }];
              }

              break;
            }

            case 'SUMMARIZING': {
              menu = [
                {
                  title: 'Отменить тендер',
                  event: 'open-cancel-modal',
                  pos: 1
                }
              ];

              if (this.tenderInfo.type === 'RFQ') {
                menu.push(newStageButton)
              }

              break;
            }

            case 'COMPLETED': {
              menu = [
                {
                  title: 'Отправить в архив',
                  event: 'archive-tender',
                  pos: 1
                }
              ];

              if (this.tenderInfo.type === 'RFQ') {
                menu.push(newStageButton)
              }

              break;
            }

            case 'CANCELLED': {
              menu = [
                {
                  title: 'Отправить в архив',
                  event: 'archive-tender',
                  pos: 1
                }
              ];
              break;
            }
          }

          menu = [...menu, {
            title: 'Дублировать тендер',
            event: 'duplicate-tender',
            pos: 2
          }]
        } else {
          switch (this.tenderInfo.status) {
            case 'HELD': {
              switch(this.tenderInfo.participationStatus) {
                case 'NOT_VIEWED':
                case 'VIEWED': {
                  menu = [
                    {
                      title: 'Отказаться от участия',
                      event: 'reject-participation',
                      pos: 1
                    }
                  ];
                  break;
                }
                case 'REPLIED': {
                  if (this.tenderInfo.type === 'RFQ') {
                    menu = [
                      {
                        title: 'Отозвать на редактирование',
                        event: 'open-recall-modal',
                        pos: 1
                      }
                    ] 
                  }
                  break;
                }
              }
              break;
            }
          }
        }

        return menu.sort((a, b) => a.pos - b.pos)
      }
    },
    mounted () {
      this.$watch('$refs.menu.isOpened', isOpened => this.$emit('toggle', isOpened))
    },
    methods: {
      ...mapActions({
        getTender: "tenders/getTender",
        duplicateTender: "tenders/duplicateTender",
        deleteTender: "tenders/deleteTender",
        cancelTender: "tenders/cancelTender",
        manualFinishTender: "tenders/manualFinishTender"
      }),
      openModal (name) {
        this.$refs[name].open();
      },
      async checkCompactMode () {
        if (this.compactMode) {
          await this.getTender({
            type: this.tenderInfo.type,
            uuid: this.tenderInfo.uuid
          })
        }
      },
      async createNewStage () {
        if (!this.isScenarioWinnerExists) {
          return
        }

        this.isMenuPending = true

        const notificationId = `${new Date().getTime()}submit`;

        this.$notification({
          type: 'system_notification_in_load',
          message: 'Создание нового этапа',
          id: notificationId
        });

        try {
          const newTenderUuid = uuid.v4();

          await api.tenders.createNewStage(this.tenderInfo.uuid, newTenderUuid);

          this.$emit("reload-tender");

          this.$router.push({ path: `/tenders/${newTenderUuid}/common`, query: { ...this.$route.query } });

          this.$notification({
            type: 'system_notification_success',
            message: 'Новый этап успешно создан'
          });
        } catch (e) {
          console.error(e);

          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка создания нового этапа'
          });
        }

        this.$notification({
          event: 'close',
          id: notificationId
        })

        this.isMenuPending = false
      },
      async archiveTender () {
        const notificationId = `${new Date().getTime()}submit`;

        this.$notification({
          type: 'system_notification_in_load',
          message: 'Архивация тендера',
          id: notificationId
        });

        try {
          await api.tenders.archiveTender(this.tenderInfo.type, this.tenderInfo.uuid);

          this.$notification({
            id: notificationId,
            event: 'close'
          });

          if (this.compactMode) {
            this.$notification({
              type: 'snackbars',
              message: `Тендер ${this.tenderInfo.number} перемещен в Архив`,
              timeout: 6000,
              onclick: {
                label: 'Перейти',
                action: () => {
                  this.$router.push({
                    path: `/tenders/${this.tenderInfo.uuid}/common`,
                    query: { ...this.$route.query }
                  });

                  this.$emit("reload-tender");
                }
              }
            });
          } else {
            this.$notification({
              type: 'system_notification_success',
              message: `Тендер ${this.tenderInfo.number} перемещен в Архив`
            });
          }

          this.$emit("load-data");
          this.$emit("reload-tender");
        } catch (e) {
          console.error(e);

          this.$notification({
            id: notificationId,
            event: 'close'
          });

          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка архивации тендера'
          });
        }
      },
      async onDuplicateTender () {
        await this.checkCompactMode()

        const id = new Date().getTime() + 'save';

        const newTenderUuid = uuid.v4();

        this.$notification({
          id,
          type: 'system_notification_in_load',
          message: 'Дублирование'
        });

        try {
          await this.duplicateTender({ newTenderUuid });

          setTimeout(() => {
            if (this.compactMode) {
              this.$emit('load-data');
            }

            this.$notification({
              id,
              event: 'close'
            });

            this.$notification({
              type: 'snackbars',
              message: `Создан дубликат тендера`,
              timeout: 6000,
              onclick: {
                label: 'Перейти',
                action: () => {
                  this.$router.push({
                    path: `/tenders/${newTenderUuid}/common`,
                    query: { ...this.$route.query }
                  });

                  this.$emit("reload-tender");
                }
              }
            });
          }, 1000);
        } catch(e) {
          console.error(e);

          this.$notification({ event: 'close', id });
          this.$notification({ type: 'system_notification_error', message: e })
        }
      },
      async rejectTender () {
        await api.tenders.rejectTenderParticipationByTypeAndUuid(this.tenderInfo.type, this.tenderInfo.uuid)

        this.goToTendersList()
      },
      async onDeleteModalConfirm () {
        await this.checkCompactMode()
        await this.deleteTender()

        this.goToTendersList()

        this.$notification({
          type: 'system_notification_success',
          message: 'Тендер успешно удалён'
        })
      },
      async onCancelModalConfirm () {
        await this.checkCompactMode()
        await this.cancelTender({
          comment: this.cancelTenderComment
        })

        this.goToTendersList()

        this.$notification({
          type: 'system_notification_success',
          message: 'Тендер успешно отменён'
        })

        if (this.compactMode) {
          this.$refs["cancel-modal"].close();
        }
      },
      goToTendersList () {
        if (this.compactMode) {
          this.$emit('load-data')
        } else {
          this.$router.push({ path: '/tenders' })
        }
      },
      async onManualFinishModalConfirm () {
        try {
          await this.manualFinishTender();
          
          this.$notification({
            type: 'snackbars',
            message: `Тендер досрочно завершён`,
            timeout: 6000
          });
          
          this.$refs["manual-finish-modal"].close();

          this.$emit("reload-tender");

        } catch(e) {
          console.error(e);
          
          this.$notification({
            type: 'system_notification_error',
            message: e
          })
        }
      },
      async onRecallOfferModalConfirm () {
        try {
          await api.tenders.recallTenderOfferByUuid(this.tender.offers[0], { tenderUuid: this.tender.tenderInfo.uuid })

          this.$notification({
            type: 'snackbars',
            message: `Тендер отозван на редактирование`,
            timeout: 6000,
          });

          this.$refs["recall-modal"].close();

          this.$emit("reload-tender");

        } catch(e) {
          console.error(e);
          this.$notification({ type: 'system_notification_error', message: e })
        }
      },
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .tender-menu::v-deep {
    cursor: auto;

    .col-right__description {
      white-space: normal;
      min-width: 180px;
    }

    .tender-menu-button {
      &.manual-finish {
        width: 265px;
        white-space: normal;
        color: $color-grey-label;
      }

      &.disabled {
        pointer-events: none;
      }
    }
  }

  .modal-tender-text {
    @include font-mixin(16px, 20px, 400, $color-text-base);

    word-break: break-word;

    &:not(:last-child) {
      margin-bottom: 20px;
    }
  }
</style>